<script lang="ts">
  import { onMount } from 'svelte';
  import { Tooltip } from 'sveltestrap';

  export let status: string;
  export let feedback: string | undefined;

  let statusIcon: HTMLSpanElement;
  let statusClasses: Array<Object> = [];
  // success, partial, failure, timeout, and error
  onMount(() => {
    switch (status) {
      case 'success':
        statusClasses = [{ class: 'fa fa-arrow-circle-up text-success fs-1 fa-stack-1x' }];
        break;
      case 'failure':
        statusClasses = [{ class: 'fa fa-arrow-circle-down text-danger fs-1 fa-stack-1x' }];
        break;
      case 'partial':
        statusClasses = [{ class: 'fa fa-exclamation-circle text-warning fs-1 fa-stack-1x' }];
        break;
      case 'timeout':
        statusClasses = [
          { class: 'fa-solid fa-spinner fa-pulse fs-1 fa-stack-1x', style: '--fa-animation-duration: 5s;' },
        ];
        if (!feedback) {
          feedback = 'Timeout';
        }
        break;
      default:
        statusClasses = [{ class: 'fa fa-question-circle text-muted fs-1 fa-stack-1x' }];
        break;
    }
  });
</script>

<span bind:this={statusIcon} class="fa-stack" aria-hidden="true">
  {#each statusClasses as sc}
    <i class={sc.class} style={sc.style} />
  {/each}
</span>
{#if feedback && feedback.length > 0}
  <Tooltip target={statusIcon} placement="top">
    {@html feedback}
  </Tooltip>
{/if}
